package linked_list;

class Item<T> {
    public Item(T value, Item<T> next) {
        this.value = value;
        this.next = next;
    }
    public Item<T> next() { return next; }
    public void next(Item<T> next) { this.next = next; }
    public T value() { return value; }
    public void value(T value) { this.value = value; }
    private T value;
    private Item<T> next;
}

class LinkedList<T> {
    private Item<T> head;

    public LinkedList() { head = null; }

    // returns 0 on success, -1 on failure
    public int insert(T new_value) {
    	head = new Item<T>(new_value, head);
    	return (head != null) ? 0 : -1;
    }

    // returns 0 on success, -1 on failure
    public int remove (T v) {
        Item<T> m = head;
        Item<T> temp = null;  // temp points to one behind as we iterate

        while ( m != null) {
        if (m.value() == v) {
    	if (temp == null) { // marker is the first element in the list
        if (m.next() == null) {
        head = null;
    	m = null;
    	}else{
        head = new Item<T>(m.value(), m.next());


        m = null; }
        return 0; } else {
        temp.next (m.next());
                temp = null;
            	    return 0;
                } }
            m = null;  // reset the marker
            temp = m;
            m = m.next();
	}




	return -1; // failure
    }

    // find a value in list
    // return value if it’s in the list, return null otherwise
        public Item<T> foo(T value) {
            Item<T> marker=head.next();
            while(marker!=null){ if(marker.value()==value) return marker; }
        	return null;
        }

            public void print() {
                Item<T> marker = head;
                System.out.println("Current state of list:");
                do {
                    System.out.println(marker.value());
                    marker = marker.next();
                } while (marker != null);
            }

                public void clear() {
                    Item<T> marke = head;
                    while (marker != null) {
                        Item<T> temp =marker;
        	    temp = marker.next();
   	            }
                }






    public void run() {
        LinkedList<Integer> list = new LinkedList<Integer>();
        System.out.println("Adding elements:");
        list.insert (1);
        list.insert (2);
        list.insert (3);
        list.insert (4);
        Item<Integer> query = list.find(3);
        System.out.println("Searching 3: found " + query.value().toString() );
	list.print();
	System.out.println("Removing elements:");
	list.remove(2);
        list.print();
        list.remove(4);
	list.print();
        list.remove(1);
        list.print();
        list.remove(2);
        list.print();
        list.remove(3);
        list.print();
        list.clear();
    }

    public static void main(String args[]) {
        LinkedList debugMe = new LinkedList();
        debugMe.run();
    }
}
